; GUI #
include win64a.inc
ZZZ_OPEN	equ  1
ZZZ_SAVE	equ  2
ZZZ_EXIT	equ  3
MAXSIZE		equ 256
MEM_SIZE	equ 65535
EditID		equ 1
IDR_MAINMENU	equ 30

.code
WinMain proc <20>
local msg:MSG

	xor	ebx,ebx
	mov	edi,offset ClassName
	mov	esi,IMAGE_BASE
	invoke	LoadCursorFromFileA,"br_Rabbit3.cur";&FileName
	push	rax 	;hIconSm
	push	rdi	;lpszClassName
	push	IDR_MAINMENU;lpszMenuName
	push	COLOR_WINDOW;hbrBackground
	push	rax	;hCursor
	push	rax        ;hIcon
	push	rsi	;hInstance
	push	rbx        ;cbClsExtra & cbWndExtra
	pushaddr WndProc;lpfnWndProc
	push	sizeof WNDCLASSEX;cbSize & style
	invoke	RegisterClassExA,esp	;addr WNDCLASSEX	
	push	rbx
	push	rsi
	shl	esi,9	;rsi=512*400000h=CW_USEDEFAULT
	push	rbx
	push	rbx
	push	rsi
	push	rsi
	push	rsi
	push	rsi
	sub	esp,20h
    	invoke	CreateWindowExA,WS_EX_CLIENTEDGE,edi,edi,WS_OVERLAPPEDWINDOW or WS_VISIBLE
	invoke	SetFocus,hwndEdit
    	lea	edi,msg
@@:	invoke	GetMessageA,edi,0,0,0
	invoke	TranslateMessage,edi
	invoke	DispatchMessageA,edi
	jmp @b
WinMain endp

WndProc proc <12> hWnd:HWND, uMsg:UINT, wParam:WPARAM, lParam:LPARAM
local	szReadWrite:QWORD	;number of bytes actually read or write

	mov	hWnd,rcx
	mov	wParam,r8
	mov	lParam,r9

	cmp	edx,WM_DESTROY
	je	wmDESTROY
	cmp	edx,WM_COMMAND
	je	wmCOMMAND
	cmp	edx,WM_CREATE
	je	wmCREATE
	cmp	edx,WM_SIZE
	je	wmSIZE
	leave
	jmp	NtdllDefWindowProc_

wmDESTROY:invoke GlobalFree,hMem
	invoke	CloseHandle,hFile
	invoke	RtlExitUserProcess,0
wmSIZE:	movzx	eax,word ptr lParam+2
	movzx	r9,r9w;word ptr lParam
	mov	qword ptr[rsp+28h],TRUE
	mov	[rsp+20h],rax
	invoke	MoveWindow,hwndEdit,0,0
	jmp	wmBYE
OPEN:	invoke	GetOpenFileName,&dlgOpenOfn
	test	eax,eax
	je	wmBYE
	and	qword ptr[rsp+30h],0
	mov	qword ptr[rsp+28h],FILE_ATTRIBUTE_NORMAL
	mov	qword ptr[rsp+20h],OPEN_EXISTING
	invoke	CreateFile,&Buffer,GENERIC_READ or GENERIC_WRITE,FILE_SHARE_READ,0
	mov	hFile,rax;handle to file
	invoke	GetFileSize,eax,0
	mov	FileSize,rax      
	and	qword ptr[rsp+20h],0
	invoke	ReadFile,hFile,hMem,eax,&szReadWrite
;           
	invoke	SetWindowTextA,hwndEdit,hMem
;  -   
	movzx	edx,dlgOpenOfn.nFileOffset
	add	edx,offset Buffer
	invoke	SetWindowTextA,hWnd
	jmp	wmBYE
SAVE:;     
        invoke	GetWindowTextLengthA,hwndEdit
	inc	eax
	mov	FileSize,rax
;      
	invoke	GetWindowTextA,hwndEdit,hMem,FileSize
        invoke	SetFilePointer,hFile,0,0,FILE_BEGIN
;     
	and	qword ptr[rsp+20h],0
	invoke	WriteFile,hFile,hMem,FileSize,&szReadWrite
	jmp	wmBYE
wmCREATE:mov	dlgOpenOfn.hwndOwner,rcx
	push	0
	push	IMAGE_BASE
	push	EditID
	push	rcx
	push	0
	push	0
	push	0
	push	0
	sub	esp,20h
	invoke	CreateWindowExA,0,"edit",0,WS_VISIBLE or WS_CHILD or ES_LEFT \
	or ES_MULTILINE or WS_VSCROLL or WS_HSCROLL or ES_AUTOHSCROLL or ES_AUTOVSCROLL
	mov	hwndEdit,rax
; 
    	invoke  GlobalAlloc,GPTR,MEM_SIZE;GMEM_MOVEABLE=2 or GMEM_ZEROINIT=40h
    	mov 	hMem,rax
        jmp	wmBYE
wmCOMMAND:movzx	r8d,word ptr wParam
	or	r9,r9	;cmp lParam,0
	jnz	wmBYE
	cmp	r8d,ZZZ_EXIT
	ja	wmBYE
	jmp	[menu_handlers+r8*8]
EXIT:	invoke	DestroyWindow,hWnd
wmBYE:  leave
        retn
menu_handlers	dq wmBYE,OPEN,SAVE,EXIT
WndProc endp
;---------------------------------------
.data
ClassName	db '    : GlobalAlloc, GlobalFree',0
dlgOpenTitle	db ' ',0
;------------------------------------------
align 8
dlgOpenOfn  label  OPENFILENAME
dd sizeof OPENFILENAME,?;lStructSize
dq ?            ;hwndOwner
dq IMAGE_BASE   ;hInstance
dq FilterString ;lpstrFilter
dq ?            ;lpstrCustomFilter  QWORD      ?
dd ?            ;nMaxCustFilter     DWORD      ?
dd ?            ;nFilterIndex       DWORD      ?
dq Buffer       ;lpstrFile          QWORD      ?
dd MAXSIZE,?    ;nMaxFile           DWORD      ?,?
dq ?            ;lpstrFileTitle     QWORD      ?
dd ?,?          ;nMaxFileTitle      DWORD      ?,?
dq ?            ;lpstrInitialDir    QWORD      ?
dq dlgOpenTitle ;lpstrTitle         QWORD      ?
dd OFN_FILEMUSTEXIST or OFN_PATHMUSTEXIST or \
OFN_LONGNAMES or OFN_EXPLORER or OFN_HIDEREADONLY;Flags              DWORD      ?
dw ?            ;nFileOffset         WORD      ?
dw ?            ;nFileExtension      WORD      ?
dq ?            ;lpstrDefExt        QWORD      ?
dd ?,?          ;lCustData          DWORD      ?,?
dq ?            ;lpfnHook           QWORD      ?
dq ?            ;lpTemplateName     QWORD
;-------------------------------------------
FilterString	db 'All Files (*.*)',0,'*.*',0
		db 'Text Files (*.txt)',0,'*.txt',0,0
.data?
hwndEdit	dq ? ;handle for edit control
hHeap		dq ?
hMem		dq ?
FileSize	dq ?
hFile		dq ?;handle of file
Buffer		db MAXSIZE dup(?)
end