; GUI #
include win64a.inc
ZZZ_OPEN	equ  1
ZZZ_SAVE	equ  2
ZZZ_EXIT	equ  3
MAXSIZE		equ 256
MEM_SIZE	equ 65535
EditID		equ 1
IDR_MAINMENU	equ 30

.code
WinMain proc <20>
local msg:MSG

	xor	ebx,ebx
	mov	edi,offset ClassName
	mov	esi,IMAGE_BASE
	invoke	LoadCursorFromFileA,"br_Rabbit3.cur"
	push	rax 	;hIconSm
	push	rdi	;lpszClassName
	push	IDR_MAINMENU;lpszMenuName
	push	COLOR_WINDOW;hbrBackground
	push	rax	;hCursor
	push	rax        ;hIcon
	push	rsi	;hInstance
	push	rbx        ;cbClsExtra & cbWndExtra
	pushaddr WndProc;lpfnWndProc
	push	sizeof WNDCLASSEX;cbSize & style
	invoke	RegisterClassExA,esp	;addr WNDCLASSEX	
	push	rbx
	push	rsi
	shl	esi,9	;rsi=512*400000h=CW_USEDEFAULT
	push	rbx
	push	rbx
	push	rsi
	push	rsi
	push	rsi
	push	rsi
	sub	esp,20h
    	invoke	CreateWindowExA,WS_EX_CLIENTEDGE,edi,edi,WS_OVERLAPPEDWINDOW or WS_VISIBLE
	invoke	GetMenu,eax
	mov	hMenu,rax
	invoke	SetFocus,hwndEdit
    	lea	edi,msg
@@:	invoke	GetMessageA,edi,0,0,0
	invoke	TranslateMessage,edi
	invoke	DispatchMessageA,edi
	jmp @b
WinMain endp

WndProc proc <12> hWnd:HWND, uMsg:UINT, wParam:WPARAM, lParam:LPARAM
local hFile:QWORD	;handle of file
local szReadWrite:QWORD	;number of bytes actually read or write
	mov	wParam,r8
	mov	lParam,r9
	mov	hWnd,rcx

	cmp  edx,WM_DESTROY
	je   wmDESTROY
	cmp  edx,WM_COMMAND
	je   wmCOMMAND
	cmp  edx,WM_CREATE
	je   wmCREATE
	cmp  edx,WM_SIZE
	je   wmSIZE
	leave
	jmp NtdllDefWindowProc_

wmDESTROY:test	OpenFlag,1
	jnz	@f
	invoke	UnmapViewOfFile,pMapping
	invoke	CloseHandle,hMapping
	invoke	CloseHandle,hFile
@@:	invoke	RtlExitUserProcess,NULL
wmSIZE:	mov	eax,r9d
	shr	eax,16;word ptr lParam+2
	and	r9d,0FFFFh;word ptr lParam
	invoke	MoveWindow,hwndEdit,0,0,,eax,TRUE
	jmp	wmBYE
OPEN:	test	OpenFlag,1
	jnz	@f
	invoke	UnmapViewOfFile,pMapping
	invoke	CloseHandle,hMapping
	invoke	CloseHandle,hFile
	and	OpenFlag,0
@@:	mov	dlgOpenOfn.Flags,OFN_FILEMUSTEXIST or OFN_PATHMUSTEXIST or\
	OFN_LONGNAMES or OFN_EXPLORER or OFN_HIDEREADONLY
	invoke	GetOpenFileName,&dlgOpenOfn
	test	eax,eax
	je	wmBYE
	and	qword ptr[rsp+30h],0
	mov	qword ptr[rsp+28h],FILE_ATTRIBUTE_ARCHIVE
	mov	qword ptr[rsp+20h],OPEN_EXISTING
	invoke	CreateFile,&dOpenBuffer,GENERIC_READ or GENERIC_WRITE,FILE_SHARE_READ or FILE_SHARE_WRITE,0
	mov	hFile,rax;handle to file
;    " "
	and	qword ptr[rsp+28h],0
	mov	qword ptr[rsp+20h],MEM_SIZE
	invoke	CreateFileMapping,eax,0,PAGE_READWRITE,0
	mov	hMapping,rax
;      
	and	qword ptr[rsp+20h],0
	invoke	MapViewOfFile,eax,FILE_MAP_WRITE,0,0
	mov	pMapping,rax
	invoke	SendMessageA,hwndEdit,WM_SETTEXT,0,eax
	movzx	edx,dlgOpenOfn.nFileOffset
	add	edx,offset dOpenBuffer
	invoke	SetWindowTextA,hWnd
	or	OpenFlag,1
	jmp	wmBYE
SAVE:	invoke	SendMessageA,hwndEdit,WM_GETTEXT,MEM_SIZE,pMapping
	jmp	wmBYE
wmCREATE:mov	dlgOpenOfn.hwndOwner,rcx
	push	0
	push	IMAGE_BASE
	push	EditID
	push	rcx
	push	0
	push	0
	push	0
	push	0
	sub	esp,20h
	invoke	CreateWindowExA,0,"edit",0,WS_VISIBLE or WS_CHILD or ES_LEFT \
	or ES_MULTILINE or WS_VSCROLL or WS_HSCROLL or ES_AUTOHSCROLL or ES_AUTOVSCROLL
	mov	hwndEdit,rax
        jmp	wmBYE
wmCOMMAND:movzx	r8d,word ptr wParam
	or	r9,r9	;cmp lParam,0
	jnz	wmBYE
	cmp	r8d,ZZZ_EXIT
	ja	wmBYE
	jmp	[menu_handlers+r8*8]
EXIT:	invoke	DestroyWindow,hWnd
wmBYE:  leave
        retn
menu_handlers	dq wmBYE,OPEN,SAVE,EXIT
WndProc endp
;---------------------------------------
.data
ClassName	db '   ',0
dlgOpenTitle	db ' ',0
;------------------------------------------
align 8
dlgOpenOfn	label  OPENFILENAME 
dd sizeof OPENFILENAME,?;lStructSize
dq ?            ;hwndOwner
dq IMAGE_BASE   ;hInstance
dq FilterString ;lpstrFilter
dq ?            ;lpstrCustomFilter  QWORD      ?
dd ?            ;nMaxCustFilter     DWORD      ?
dd ?            ;nFilterIndex       DWORD      ?
dq Buffer       ;lpstrFile          QWORD      ?
dd MAXSIZE,?    ;nMaxFile           DWORD      ?,?
dq ?            ;lpstrFileTitle     QWORD      ?
dd ?,?          ;nMaxFileTitle      DWORD      ?,?
dq ?            ;lpstrInitialDir    QWORD      ?
dq dlgOpenTitle ;lpstrTitle         QWORD      ?
dd OFN_FILEMUSTEXIST or OFN_PATHMUSTEXIST or \
OFN_LONGNAMES or OFN_EXPLORER or OFN_HIDEREADONLY;Flags              DWORD      ?
dw ?            ;nFileOffset         WORD      ?
dw ?            ;nFileExtension      WORD      ?
dq ?            ;lpstrDefExt        QWORD      ?
dd ?,?          ;lCustData          DWORD      ?,?
dq ?            ;lpfnHook           QWORD      ?
dq ?            ;lpTemplateName     QWORD
;-------------------------------------------
FilterString	db 'All Files (*.*)',0,'*.*',0
		db 'Text Files (*.txt)',0,'*.txt',0,0
.data?
dOpenBuffer	db MAXSIZE dup(?)
hwndEdit	dq ? ;handle for edit control
hMapping	dq ? ;file mapped handle
pMapping	dq ?
hMenu		dq ?
OpenFlag	db 0
end